diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-extension.cc ns-3.31/src/internet/model/ipv6-extension.cc
--- ns-3.30.1/src/internet/model/ipv6-extension.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-extension.cc	2020-06-27 17:38:30.000000000 -0700
@@ -61,14 +61,11 @@
 
 Ipv6Extension::Ipv6Extension ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   m_uvar = CreateObject<UniformRandomVariable> ();
 }
 
 Ipv6Extension::~Ipv6Extension ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 void Ipv6Extension::SetNode (Ptr<Node> node)
@@ -80,8 +77,6 @@
 
 Ptr<Node> Ipv6Extension::GetNode () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return m_node;
 }
 
@@ -201,18 +196,14 @@
 
 Ipv6ExtensionHopByHop::Ipv6ExtensionHopByHop ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionHopByHop::~Ipv6ExtensionHopByHop ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 uint8_t Ipv6ExtensionHopByHop::GetExtensionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return EXT_NUMBER;
 }
 
@@ -261,18 +252,14 @@
 
 Ipv6ExtensionDestination::Ipv6ExtensionDestination ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionDestination::~Ipv6ExtensionDestination ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 uint8_t Ipv6ExtensionDestination::GetExtensionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return EXT_NUMBER;
 }
 
@@ -315,23 +302,27 @@
     .SetParent<Ipv6Extension> ()
     .SetGroupName ("Internet")
     .AddConstructor<Ipv6ExtensionFragment> ()
+    .AddAttribute ("FragmentExpirationTimeout",
+                   "When this timeout expires, the fragments "
+                   "will be cleared from the buffer.",
+                   TimeValue (Seconds (60)),
+                   MakeTimeAccessor (&Ipv6ExtensionFragment::m_fragmentExpirationTimeout),
+                   MakeTimeChecker ())
   ;
   return tid;
 }
 
 Ipv6ExtensionFragment::Ipv6ExtensionFragment ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionFragment::~Ipv6ExtensionFragment ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 void Ipv6ExtensionFragment::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   for (MapFragments_t::iterator it = m_fragments.begin (); it != m_fragments.end (); it++)
     {
@@ -339,13 +330,16 @@
     }
 
   m_fragments.clear ();
+  m_timeoutEventList.clear ();
+  if (m_timeoutEvent.IsRunning ())
+    {
+      m_timeoutEvent.Cancel ();
+    }
   Ipv6Extension::DoDispose ();
 }
 
 uint8_t Ipv6ExtensionFragment::GetExtensionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return EXT_NUMBER;
 }
 
@@ -376,21 +370,20 @@
   uint32_t identification = fragmentHeader.GetIdentification ();
   Ipv6Address src = ipv6Header.GetSourceAddress ();
 
-  std::pair<Ipv6Address, uint32_t> fragmentsId = std::pair<Ipv6Address, uint32_t> (src, identification);
+  FragmentKey_t fragmentKey = FragmentKey_t (src, identification);
   Ptr<Fragments> fragments;
 
   Ipv6Header ipHeader = ipv6Header;
   ipHeader.SetNextHeader (fragmentHeader.GetNextHeader ());
 
-  MapFragments_t::iterator it = m_fragments.find (fragmentsId);
+  MapFragments_t::iterator it = m_fragments.find (fragmentKey);
   if (it == m_fragments.end ())
     {
       fragments = Create<Fragments> ();
-      m_fragments.insert (std::make_pair (fragmentsId, fragments));
-      EventId timeout = Simulator::Schedule (Seconds (60),
-                                             &Ipv6ExtensionFragment::HandleFragmentsTimeout, this,
-                                             fragmentsId, ipHeader);
-      fragments->SetTimeoutEventId (timeout);
+      m_fragments.insert (std::make_pair (fragmentKey, fragments));
+      NS_LOG_DEBUG ("Insert new fragment key: src: " << src << " IP hdr id " << identification << " m_fragments.size() " << m_fragments.size () << " offset " << fragmentOffset);
+      FragmentsTimeoutsListI_t iter = SetTimeout (fragmentKey, ipHeader);
+      fragments->SetTimeoutIter (iter);
     }
   else
     {
@@ -404,13 +397,15 @@
       fragments->SetUnfragmentablePart (unfragmentablePart);
     }
 
+  NS_LOG_DEBUG ("Add fragment with IP hdr id " << identification << " offset " << fragmentOffset);
   fragments->AddFragment (p, fragmentOffset, moreFragment);
 
   if (fragments->IsEntire ())
     {
       packet = fragments->GetPacket ();
-      fragments->CancelTimeout ();
-      m_fragments.erase (fragmentsId);
+      m_timeoutEventList.erase (fragments->GetTimeoutIter ());
+      m_fragments.erase (fragmentKey);
+      NS_LOG_DEBUG ("Finished fragment with IP hdr id " << fragmentKey.second << " erase timeout, m_fragments.size(): " << m_fragments.size ());
       stopProcessing = false;
     }
   else
@@ -423,6 +418,7 @@
 
 void Ipv6ExtensionFragment::GetFragments (Ptr<Packet> packet, Ipv6Header ipv6Header, uint32_t maxFragmentSize, std::list<Ipv6PayloadHeaderPair>& listFragments)
 {
+  NS_LOG_FUNCTION (this << packet << ipv6Header << maxFragmentSize);
   Ptr<Packet> p = packet->Copy ();
 
   uint8_t nextHeader = ipv6Header.GetNextHeader ();
@@ -466,7 +462,7 @@
               hopbyhopHeader->SetNextHeader (Ipv6Header::IPV6_EXT_FRAGMENTATION);
             }
 
-          unfragmentablePart.push_back (std::pair<Ipv6ExtensionHeader *, uint8_t> (hopbyhopHeader, Ipv6Header::IPV6_EXT_HOP_BY_HOP));
+          unfragmentablePart.emplace_back (hopbyhopHeader, Ipv6Header::IPV6_EXT_HOP_BY_HOP);
           unfragmentablePartSize += extensionHeaderLength;
         }
       else if (nextHeader == Ipv6Header::IPV6_EXT_ROUTING)
@@ -490,7 +486,7 @@
               routingHeader->SetNextHeader (Ipv6Header::IPV6_EXT_FRAGMENTATION);
             }
 
-          unfragmentablePart.push_back (std::pair<Ipv6ExtensionHeader *, uint8_t> (routingHeader, Ipv6Header::IPV6_EXT_ROUTING));
+          unfragmentablePart.emplace_back (routingHeader, Ipv6Header::IPV6_EXT_ROUTING);
           unfragmentablePartSize += extensionHeaderLength;
         }
       else if (nextHeader == Ipv6Header::IPV6_EXT_DESTINATION)
@@ -510,7 +506,7 @@
               destinationHeader->SetNextHeader (Ipv6Header::IPV6_EXT_FRAGMENTATION);
             }
 
-          unfragmentablePart.push_back (std::pair<Ipv6ExtensionHeader *, uint8_t> (destinationHeader, Ipv6Header::IPV6_EXT_DESTINATION));
+          unfragmentablePart.emplace_back (destinationHeader, Ipv6Header::IPV6_EXT_DESTINATION);
           unfragmentablePartSize += extensionHeaderLength;
         }
     }
@@ -581,7 +577,7 @@
       oss << ipv6Header;
       fragment->Print (oss);
 
-      listFragments.push_back (Ipv6PayloadHeaderPair (fragment, ipv6Header));
+      listFragments.emplace_back (fragment, ipv6Header);
     }
   while (moreFragment);
 
@@ -594,19 +590,20 @@
 }
 
 
-void Ipv6ExtensionFragment::HandleFragmentsTimeout (std::pair<Ipv6Address, uint32_t> fragmentsId,
+void Ipv6ExtensionFragment::HandleFragmentsTimeout (FragmentKey_t fragmentKey,
                                                     Ipv6Header ipHeader)
 {
+  NS_LOG_FUNCTION (this << fragmentKey.first << fragmentKey.second << ipHeader);
   Ptr<Fragments> fragments;
 
-  MapFragments_t::iterator it = m_fragments.find (fragmentsId);
+  MapFragments_t::iterator it = m_fragments.find (fragmentKey);
   NS_ASSERT_MSG(it != m_fragments.end (), "IPv6 Fragment timeout reached for non-existent fragment");
   fragments = it->second;
 
   Ptr<Packet> packet = fragments->GetPartialPacket ();
 
   // if we have at least 8 bytes, we can send an ICMP.
-  if ( packet->GetSize () > 8 )
+  if (packet && packet->GetSize () > 8)
     {
       Ptr<Packet> p = packet->Copy ();
       p->AddHeader (ipHeader);
@@ -618,9 +615,58 @@
   ipL3->ReportDrop (ipHeader, packet, Ipv6L3Protocol::DROP_FRAGMENT_TIMEOUT);
 
   // clear the buffers
-  m_fragments.erase (fragmentsId);
+  m_fragments.erase (fragmentKey);
 }
 
+
+Ipv6ExtensionFragment::FragmentsTimeoutsListI_t Ipv6ExtensionFragment::SetTimeout (FragmentKey_t key, Ipv6Header ipHeader)
+{
+  NS_LOG_FUNCTION (this << key.first << key.second << ipHeader);
+  if (m_timeoutEventList.empty ())
+    {
+      NS_LOG_DEBUG ("Scheduling timeout for IP hdr id " << key.second << " at time " << (Simulator::Now () + m_fragmentExpirationTimeout).GetSeconds ());
+      m_timeoutEvent = Simulator::Schedule (m_fragmentExpirationTimeout, &Ipv6ExtensionFragment::HandleTimeout, this);
+    }
+  NS_LOG_DEBUG ("Adding timeout at " << (Simulator::Now () + m_fragmentExpirationTimeout).GetSeconds () << " with key " << key.second);
+  m_timeoutEventList.emplace_back (Simulator::Now () + m_fragmentExpirationTimeout, key, ipHeader);
+
+  Ipv6ExtensionFragment::FragmentsTimeoutsListI_t iter = --m_timeoutEventList.end();
+
+  return (iter);
+}
+
+void Ipv6ExtensionFragment::HandleTimeout (void)
+{
+  NS_LOG_FUNCTION (this);
+  Time now = Simulator::Now ();
+
+  // std::list Time, Fragment_key_t, Ipv6Header
+  // Fragment key is a pair: Ipv6Address, uint32_t ipHeaderId
+  for (auto & element : m_timeoutEventList)
+    {
+      NS_LOG_DEBUG ("Handle time " << std::get<0> (element).GetSeconds () << " IP hdr id " << std::get<1> (element).second);
+    }
+  while (!m_timeoutEventList.empty () && std::get<0> (*m_timeoutEventList.begin ()) == now)
+    {
+      HandleFragmentsTimeout (std::get<1> (*m_timeoutEventList.begin ()),
+                              std::get<2> (*m_timeoutEventList.begin ()));
+      m_timeoutEventList.pop_front ();
+    }
+
+  if (m_timeoutEventList.empty ())
+    {
+      return;
+    }
+
+  Time difference = std::get<0> (*m_timeoutEventList.begin ()) - now;
+  NS_LOG_DEBUG ("Scheduling later HandleTimeout at " << (now + difference).GetSeconds ());
+  m_timeoutEvent = Simulator::Schedule (difference, &Ipv6ExtensionFragment::HandleTimeout, this);
+
+  return;
+}
+
+
+
 Ipv6ExtensionFragment::Fragments::Fragments ()
   : m_moreFragment (0)
 {
@@ -632,6 +678,7 @@
 
 void Ipv6ExtensionFragment::Fragments::AddFragment (Ptr<Packet> fragment, uint16_t fragmentOffset, bool moreFragment)
 {
+  NS_LOG_FUNCTION (this << fragment << fragmentOffset << moreFragment);
   std::list<std::pair<Ptr<Packet>, uint16_t> >::iterator it;
 
   for (it = m_packetFragments.begin (); it != m_packetFragments.end (); it++)
@@ -652,6 +699,7 @@
 
 void Ipv6ExtensionFragment::Fragments::SetUnfragmentablePart (Ptr<Packet> unfragmentablePart)
 {
+  NS_LOG_FUNCTION (this << unfragmentablePart);
   m_unfragmentable = unfragmentablePart;
 }
 
@@ -718,16 +766,16 @@
   return p;
 }
 
-void Ipv6ExtensionFragment::Fragments::SetTimeoutEventId (EventId event)
+void Ipv6ExtensionFragment::Fragments::SetTimeoutIter (FragmentsTimeoutsListI_t iter)
 {
-  m_timeoutEventId = event;
+  NS_LOG_FUNCTION (this);
+  m_timeoutIter = iter;
   return;
 }
 
-void Ipv6ExtensionFragment::Fragments::CancelTimeout ()
+Ipv6ExtensionFragment::FragmentsTimeoutsListI_t Ipv6ExtensionFragment::Fragments::GetTimeoutIter ()
 {
-  m_timeoutEventId.Cancel ();
-  return;
+  return m_timeoutIter;
 }
 
 
@@ -745,24 +793,19 @@
 
 Ipv6ExtensionRouting::Ipv6ExtensionRouting ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionRouting::~Ipv6ExtensionRouting ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 uint8_t Ipv6ExtensionRouting::GetExtensionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return EXT_NUMBER;
 }
 
 uint8_t Ipv6ExtensionRouting::GetTypeRouting () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
   return 0;
 }
 
@@ -850,6 +893,7 @@
 
 void Ipv6ExtensionRoutingDemux::DoDispose ()
 {
+  NS_LOG_FUNCTION (this);
   for (Ipv6ExtensionRoutingList_t::iterator it = m_extensionsRouting.begin (); it != m_extensionsRouting.end (); it++)
     {
       (*it)->Dispose ();
@@ -862,11 +906,13 @@
 
 void Ipv6ExtensionRoutingDemux::SetNode (Ptr<Node> node)
 {
+  NS_LOG_FUNCTION (this << node);
   m_node = node;
 }
 
 void Ipv6ExtensionRoutingDemux::Insert (Ptr<Ipv6ExtensionRouting> extensionRouting)
 {
+  NS_LOG_FUNCTION (this << extensionRouting);
   m_extensionsRouting.push_back (extensionRouting);
 }
 
@@ -884,6 +930,7 @@
 
 void Ipv6ExtensionRoutingDemux::Remove (Ptr<Ipv6ExtensionRouting> extensionRouting)
 {
+  NS_LOG_FUNCTION (this << extensionRouting);
   m_extensionsRouting.remove (extensionRouting);
 }
 
@@ -902,18 +949,14 @@
 
 Ipv6ExtensionLooseRouting::Ipv6ExtensionLooseRouting ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionLooseRouting::~Ipv6ExtensionLooseRouting ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 uint8_t Ipv6ExtensionLooseRouting::GetTypeRouting () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return TYPE_ROUTING;
 }
 
@@ -1066,18 +1109,14 @@
 
 Ipv6ExtensionESP::Ipv6ExtensionESP ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionESP::~Ipv6ExtensionESP ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 uint8_t Ipv6ExtensionESP::GetExtensionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return EXT_NUMBER;
 }
 
@@ -1112,18 +1151,14 @@
 
 Ipv6ExtensionAH::Ipv6ExtensionAH ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 Ipv6ExtensionAH::~Ipv6ExtensionAH ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 uint8_t Ipv6ExtensionAH::GetExtensionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
-
   return EXT_NUMBER;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-extension.h ns-3.31/src/internet/model/ipv6-extension.h
--- ns-3.30.1/src/internet/model/ipv6-extension.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-extension.h	2020-06-27 17:38:30.000000000 -0700
@@ -23,6 +23,7 @@
 
 #include <map>
 #include <list>
+#include <tuple>
 
 #include "ns3/object.h"
 #include "ns3/node.h"
@@ -316,6 +317,21 @@
   virtual void DoDispose ();
 
 private:
+
+  /**
+   * Key identifying a fragmented packet
+   */
+  typedef std::pair<Ipv6Address, uint32_t> FragmentKey_t;
+
+  /**
+   * Container for fragment timeouts.
+   */
+  typedef std::list< std::tuple <Time, FragmentKey_t, Ipv6Header > > FragmentsTimeoutsList_t;
+  /**
+   * Container Iterator for fragment timeouts.
+   */
+  typedef std::list< std::tuple <Time, FragmentKey_t, Ipv6Header > >::iterator FragmentsTimeoutsListI_t;
+
   /**
    * \ingroup ipv6HeaderExt
    *
@@ -367,15 +383,16 @@
     Ptr<Packet> GetPartialPacket () const;
 
     /**
-     * \brief Set the Timeout EventId.
-     * \param event The event.
+     * \brief Set the Timeout iterator.
+     * \param iter The iterator.
      */
-    void SetTimeoutEventId (EventId event);
+    void SetTimeoutIter (FragmentsTimeoutsListI_t iter);
 
     /**
-     * \brief Cancel the timeout event
+     * \brief Get the Timeout iterator.
+     * \returns The iterator.
      */
-    void CancelTimeout ();
+    FragmentsTimeoutsListI_t GetTimeoutIter ();
 
 private:
     /**
@@ -394,9 +411,9 @@
     Ptr<Packet> m_unfragmentable;
 
     /**
-     * \brief Timeout handler event
+     * \brief Timeout iterator to "event" handler
      */
-    EventId m_timeoutEventId;
+    FragmentsTimeoutsListI_t m_timeoutIter;
   };
 
   /**
@@ -404,7 +421,7 @@
    * \param key representing the packet fragments
    * \param ipHeader the IP header of the original packet
    */
-  void HandleFragmentsTimeout (std::pair<Ipv6Address, uint32_t> key, Ipv6Header ipHeader);
+  void HandleFragmentsTimeout (FragmentKey_t key, Ipv6Header ipHeader);
 
   /**
    * \brief Get the packet parts so far received.
@@ -426,12 +443,29 @@
   /**
    * \brief Container for the packet fragments.
    */
-  typedef std::map<std::pair<Ipv6Address, uint32_t>, Ptr<Fragments> > MapFragments_t;
+  typedef std::map<FragmentKey_t, Ptr<Fragments> > MapFragments_t;
 
   /**
    * \brief The hash of fragmented packets.
    */
   MapFragments_t m_fragments;
+
+  /**
+   * \brief Set a new timeout "event" for a fragmented packet
+   * \param key the fragment identification
+   * \param ipHeader the IPv6 header of the fragmented packet
+   * \return an iterator to the inserted "event"
+   */
+  FragmentsTimeoutsListI_t SetTimeout (FragmentKey_t key, Ipv6Header ipHeader);
+
+  /**
+   * \brief Handles a fragmented packet timeout
+   */
+  void HandleTimeout (void);
+
+  FragmentsTimeoutsList_t m_timeoutEventList;  //!< Timeout "events" container
+  EventId m_timeoutEvent;  //!< Event for the next scheduled timeout
+  Time m_fragmentExpirationTimeout; //!< Expiration timeout
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-extension-header.cc ns-3.31/src/internet/model/ipv6-extension-header.cc
--- ns-3.30.1/src/internet/model/ipv6-extension-header.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-extension-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -169,7 +169,7 @@
 
 void OptionField::AddOption (Ipv6OptionHeader const& option)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (option);
 
   uint32_t pad = CalculatePad (option.GetAlignment ());
   NS_LOG_LOGIC ("need " << pad << " bytes padding");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-interface-address.cc ns-3.31/src/internet/model/ipv6-interface-address.cc
--- ns-3.30.1/src/internet/model/ipv6-interface-address.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-interface-address.cc	2020-06-27 17:38:30.000000000 -0700
@@ -69,12 +69,12 @@
 
 Ipv6InterfaceAddress::~Ipv6InterfaceAddress ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6Address Ipv6InterfaceAddress::GetAddress () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_address;
 }
 
@@ -109,7 +109,7 @@
 
 Ipv6Prefix Ipv6InterfaceAddress::GetPrefix () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_prefix;
 }
 
@@ -121,7 +121,7 @@
 
 Ipv6InterfaceAddress::State_e Ipv6InterfaceAddress::GetState () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_state;
 }
 
@@ -133,13 +133,13 @@
 
 Ipv6InterfaceAddress::Scope_e Ipv6InterfaceAddress::GetScope () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_scope;
 }
 
 bool Ipv6InterfaceAddress::IsInSameSubnet (Ipv6Address b) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   Ipv6Address aAddr = m_address;
   aAddr = aAddr.CombinePrefix (m_prefix);
@@ -183,7 +183,7 @@
 
 uint32_t Ipv6InterfaceAddress::GetNsDadUid () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_nsDadUid;
 }
 
@@ -205,7 +205,7 @@
 
 void Ipv6InterfaceAddress::StopDadTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_dadTimer.Cancel ();
   Simulator::Cancel (m_dadId);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-interface.cc ns-3.31/src/internet/model/ipv6-interface.cc
--- ns-3.30.1/src/internet/model/ipv6-interface.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-interface.cc	2020-06-27 17:38:30.000000000 -0700
@@ -68,12 +68,11 @@
 
 Ipv6Interface::~Ipv6Interface ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
 }
 
 void Ipv6Interface::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_node = 0;
   m_device = 0;
   m_tc = 0;
@@ -83,7 +82,7 @@
 
 void Ipv6Interface::DoSetup ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   if (m_node == 0 || m_device == 0)
     {
@@ -94,47 +93,17 @@
   if (!DynamicCast<LoopbackNetDevice> (m_device)) /* no autoconf for ip6-localhost */
     {
       Address addr = GetDevice ()->GetAddress ();
-
-      if (Mac64Address::IsMatchingType (addr))
-        {
-          Ipv6InterfaceAddress ifaddr = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac64Address::ConvertFrom (addr)), Ipv6Prefix (64));
-          AddAddress (ifaddr);
-          m_linkLocalAddress = ifaddr;
-        }
-      else if (Mac48Address::IsMatchingType (addr))
-        {
-          Ipv6InterfaceAddress ifaddr = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac48Address::ConvertFrom (addr)), Ipv6Prefix (64));
-          AddAddress (ifaddr);
-          m_linkLocalAddress = ifaddr;
-        }
-      else if (Mac16Address::IsMatchingType (addr))
-        {
-          Ipv6InterfaceAddress ifaddr = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac16Address::ConvertFrom (addr)), Ipv6Prefix (64));
-          AddAddress (ifaddr);
-          m_linkLocalAddress = ifaddr;
-        }
-      else if (Mac8Address::IsMatchingType (addr))
-        {
-          Ipv6InterfaceAddress ifaddr = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac8Address::ConvertFrom (addr)), Ipv6Prefix (64));
-          AddAddress (ifaddr);
-          m_linkLocalAddress = ifaddr;
-        }
-      else
-        {
-          NS_FATAL_ERROR ("IPv6 autoconf for this kind of address not implemented.");
-        }
+      Ipv6InterfaceAddress ifaddr = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (addr), Ipv6Prefix (64));
+      AddAddress (ifaddr);
+      m_linkLocalAddress = ifaddr;
     }
   else
     {
       return; /* no NDISC cache for ip6-localhost */
     }
+  int32_t interfaceId = m_node->GetObject<Ipv6> ()->GetInterfaceForDevice (m_device);
+  Ptr<Icmpv6L4Protocol> icmpv6 = DynamicCast<Icmpv6L4Protocol> (m_node->GetObject<Ipv6> ()->GetProtocol (Icmpv6L4Protocol::GetStaticProtocolNumber (), interfaceId));
 
-  Ptr<IpL4Protocol> proto = m_node->GetObject<Ipv6> ()->GetProtocol (Icmpv6L4Protocol::GetStaticProtocolNumber ());
-  Ptr<Icmpv6L4Protocol> icmpv6;
-  if (proto)
-    {
-      icmpv6 = proto->GetObject <Icmpv6L4Protocol> ();
-    }
   if (icmpv6 && !m_ndCache)
     {
       m_ndCache = icmpv6->CreateCache (m_device, this);
@@ -145,14 +114,12 @@
 {
   NS_LOG_FUNCTION (this << node);
   m_node = node;
-  DoSetup ();
 }
 
 void Ipv6Interface::SetDevice (Ptr<NetDevice> device)
 {
   NS_LOG_FUNCTION (this << device);
   m_device = device;
-  DoSetup ();
 }
 
 void
@@ -164,7 +131,7 @@
 
 Ptr<NetDevice> Ipv6Interface::GetDevice () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_device;
 }
 
@@ -176,25 +143,25 @@
 
 uint16_t Ipv6Interface::GetMetric () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_metric;
 }
 
 bool Ipv6Interface::IsUp () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_ifup;
 }
 
 bool Ipv6Interface::IsDown () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return !m_ifup;
 }
 
 void Ipv6Interface::SetUp ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   if (m_ifup)
     {
@@ -206,7 +173,7 @@
 
 void Ipv6Interface::SetDown ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_ifup = false;
   m_addresses.clear ();
   m_ndCache->Flush ();
@@ -214,7 +181,7 @@
 
 bool Ipv6Interface::IsForwarding () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_forwarding;
 }
 
@@ -226,7 +193,7 @@
 
 bool Ipv6Interface::AddAddress (Ipv6InterfaceAddress iface)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << iface);
   Ipv6Address addr = iface.GetAddress ();
 
   /* DAD handling */
@@ -246,17 +213,21 @@
       if (!addr.IsAny () || !addr.IsLocalhost ())
         {
           /* DAD handling */
-          Ptr<IpL4Protocol> proto = m_node->GetObject<Ipv6> ()->GetProtocol (Icmpv6L4Protocol::GetStaticProtocolNumber ());
-          Ptr<Icmpv6L4Protocol> icmpv6;
-          if (proto)
-            {
-              icmpv6 = proto->GetObject <Icmpv6L4Protocol> ();
-            }
 
-          if (icmpv6 && icmpv6->IsAlwaysDad ())
+          int32_t interfaceId = m_node->GetObject<Ipv6> ()->GetInterfaceForDevice (m_device);
+          Ptr<Icmpv6L4Protocol> icmpv6 = DynamicCast<Icmpv6L4Protocol> (m_node->GetObject<Ipv6> ()->GetProtocol (Icmpv6L4Protocol::GetStaticProtocolNumber (), interfaceId));
+
+          if (icmpv6)
             {
-              Simulator::Schedule (Seconds (0.), &Icmpv6L4Protocol::DoDAD, icmpv6, addr, this);
-              Simulator::Schedule (Seconds (1.), &Icmpv6L4Protocol::FunctionDadTimeout, icmpv6, this, addr);
+              if (icmpv6->IsAlwaysDad ())
+                {
+                  Simulator::Schedule (Seconds (0.), &Icmpv6L4Protocol::DoDAD, icmpv6, addr, this);
+                  Simulator::Schedule (Seconds (1.), &Icmpv6L4Protocol::FunctionDadTimeout, icmpv6, this, addr);
+                }
+              else
+                {
+                  Simulator::Schedule (Seconds (0.), &Icmpv6L4Protocol::FunctionDadTimeout, icmpv6, this, addr);
+                }
             }
         }
       return true;
@@ -269,7 +240,7 @@
 Ipv6InterfaceAddress Ipv6Interface::GetLinkLocalAddress () const
 {
   /* IPv6 interface has always at least one IPv6 link-local address */
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   return m_linkLocalAddress;
 }
@@ -316,7 +287,7 @@
 
 uint32_t Ipv6Interface::GetNAddresses () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_addresses.size ();
 }
 
@@ -430,8 +401,11 @@
   /* other address */
   if (m_device->NeedsArp ())
     {
-      NS_LOG_LOGIC ("Needs ARP" << " " << dest);
-      Ptr<Icmpv6L4Protocol> icmpv6 = ipv6->GetIcmpv6 ();
+      NS_LOG_LOGIC ("Needs NDISC " << dest);
+
+      int32_t interfaceId = m_node->GetObject<Ipv6> ()->GetInterfaceForDevice (m_device);
+      Ptr<Icmpv6L4Protocol> icmpv6 = DynamicCast<Icmpv6L4Protocol> (m_node->GetObject<Ipv6> ()->GetProtocol (Icmpv6L4Protocol::GetStaticProtocolNumber (), interfaceId));
+
       Address hardwareDestination;
       bool found = false;
 
@@ -459,7 +433,7 @@
     }
   else
     {
-      NS_LOG_LOGIC ("Doesn't need ARP");
+      NS_LOG_LOGIC ("Doesn't need NDISC");
       m_tc->Send (m_device, Create<Ipv6QueueDiscItem> (p, m_device->GetBroadcast (), Ipv6L3Protocol::PROT_NUMBER, hdr));
     }
 }
@@ -472,7 +446,7 @@
 
 uint8_t Ipv6Interface::GetCurHopLimit () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_curHopLimit;
 }
 
@@ -484,7 +458,7 @@
 
 uint16_t Ipv6Interface::GetBaseReachableTime () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_baseReachableTime;
 }
 
@@ -496,7 +470,7 @@
 
 uint16_t Ipv6Interface::GetReachableTime () const
 {
-  NS_LOG_FUNCTION_NOARGS (); 
+  NS_LOG_FUNCTION (this);
   return m_reachableTime;
 }
 
@@ -508,7 +482,7 @@
 
 uint16_t Ipv6Interface::GetRetransTimer () const
 {
-  NS_LOG_FUNCTION_NOARGS (); 
+  NS_LOG_FUNCTION (this);
   return m_retransTimer;
 }
 
